blob: 93523146868af0628dfcc53fe18e1658faaa5ff1 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Orion Hodson64fe3be2018-06-15 12:50:22 +010044export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000048export USE_D8="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Alan Leungd5cbc562018-03-15 14:02:46 -070052# If d8 was not set by the environment variable, assume it is in the path.
53if [ -z "$D8" ]; then
54 export D8="d8"
55fi
56
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070057# If dx was not set by the environment variable, assume it is in the path.
58if [ -z "$DX" ]; then
Orion Hodson64fe3be2018-06-15 12:50:22 +010059 export DX="d8-compat-dx"
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070060fi
61
Orion Hodson64fe3be2018-06-15 12:50:22 +010062export DEXMERGER="$D8"
Alan Leungd5cbc562018-03-15 14:02:46 -070063
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080064# If jasmin was not set by the environment variable, assume it is in the path.
65if [ -z "$JASMIN" ]; then
66 export JASMIN="jasmin"
67fi
68
Andreas Gampe8fda9f22014-10-03 16:15:37 -070069# If smali was not set by the environment variable, assume it is in the path.
70if [ -z "$SMALI" ]; then
71 export SMALI="smali"
72fi
73
Sebastien Hertz19ac0272015-02-24 17:39:50 +010074# ANDROID_BUILD_TOP is not set in a build environment.
75if [ -z "$ANDROID_BUILD_TOP" ]; then
76 export ANDROID_BUILD_TOP=$oldwd
77fi
78
Dan Willemsen12371e92017-03-06 17:55:20 -080079# OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP.
80# Convert it to an absolute path, since we cd into the tmp_dir to run the tests.
81export OUT_DIR=${OUT_DIR:-out}
82if [[ "$OUT_DIR" != /* ]]; then
83 export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR
84fi
85
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086# ANDROID_HOST_OUT is not set in a build environment.
87if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsen12371e92017-03-06 17:55:20 -080088 export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070089fi
90
Alex Light680cbf22018-10-31 11:00:19 -070091host_lib_root=${ANDROID_HOST_OUT}
92
Igor Murashkine5181932017-06-15 16:03:50 -070093# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070094if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070095 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
96fi
97
Igor Murashkin271a0f82017-02-14 21:14:17 +000098# Zipalign is not on the PATH in some configs, auto-detect it.
99if [ -z "$ZIPALIGN" ]; then
100 if which zipalign >/dev/null; then
101 ZIPALIGN="zipalign";
102 else
103 # TODO: Add a dependency for zipalign in Android.run-test.mk
104 # once it doesn't depend on libandroidfw (b/35246701)
105 case "$OSTYPE" in
106 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
107 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
108 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
109 esac
110 fi
111fi
112export ZIPALIGN
113
David Brazdil122c6632018-01-24 17:32:49 +0000114# If hiddenapi was not set by the environment variable, assume it is in
115# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000116if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000117 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000118fi
119
Roland Levillain76cfe612017-10-30 13:14:28 +0000120chroot=
121
jeffhao5d1ac922011-09-29 17:41:15 -0700122info="info.txt"
123build="build"
124run="run"
Roland Levillainb15e8792020-10-28 12:20:59 +0000125expected_stdout="expected-stdout.txt"
126expected_stderr="expected-stderr.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700127check_cmd="check"
Roland Levillainb15e8792020-10-28 12:20:59 +0000128test_stdout="test-stdout.txt"
129test_stderr="test-stderr.txt"
130build_stdout="build-stdout.txt"
131build_stderr="build-stderr.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100132cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700133strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700134lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700135testlib="arttestd"
Andreas Gampe11410de2019-07-02 15:53:53 -0700136run_args=(--quiet)
David Brazdil4846d132015-01-15 19:07:08 +0000137build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700138
Alex Light91de25f2015-10-28 17:00:06 -0700139quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000140debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700141prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700142target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700143dev_mode="no"
Alex Light8d94ddd2019-12-18 11:13:03 -0800144create_runner="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700145update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700146debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000147relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800148runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700149usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700150build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700151suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700152trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700153trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700154basic_verify="false"
155gc_verify="false"
156gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700157jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700158jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700159jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700160jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700161strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700162always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700163never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700164have_image="yes"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000165android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700166bisection_search="no"
Martin Stjernholm4815e722019-09-24 16:20:09 +0100167timeout=""
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800168suspend_timeout="500000"
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100169run_optimizing="false"
jeffhao5d1ac922011-09-29 17:41:15 -0700170
Alex Light20802ca2018-12-05 15:36:03 -0800171# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
172# ART output to approximately 128MB. This should be more than sufficient
173# for any test while still catching cases of runaway output.
174# Set a hard limit to encourage ART developers to increase the ulimit here if
175# needed to support a test case rather than resetting the limit in the run
176# script for the particular test in question. Adjust this if needed for
177# particular configurations.
178file_ulimit=128000
179
Andreas Gampe11410de2019-07-02 15:53:53 -0700180
jeffhao5d1ac922011-09-29 17:41:15 -0700181while true; do
182 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700183 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700184 DEX_LOCATION=$tmp_dir
Andreas Gampe11410de2019-07-02 15:53:53 -0700185 run_args+=(--host)
jeffhao5d1ac922011-09-29 17:41:15 -0700186 shift
Alex Light91de25f2015-10-28 17:00:06 -0700187 elif [ "x$1" = "x--quiet" ]; then
188 quiet="yes"
189 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700190 elif [ "x$1" = "x--use-java-home" ]; then
191 if [ -n "${JAVA_HOME}" ]; then
192 export JAVA="${JAVA_HOME}/bin/java"
193 export JAVAC="${JAVA_HOME}/bin/javac -g"
194 else
195 echo "Passed --use-java-home without JAVA_HOME variable set!"
196 usage="yes"
197 fi
198 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800199 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700200 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800201 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800202 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700203 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700204 NEED_DEX="false"
Andreas Gampe11410de2019-07-02 15:53:53 -0700205 run_args+=(--jvm)
jeffhao5d1ac922011-09-29 17:41:15 -0700206 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800207 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700208 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700209 testlib="arttest"
Andreas Gampe11410de2019-07-02 15:53:53 -0700210 run_args+=(-O)
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700211 shift
212 elif [ "x$1" = "x--dalvik" ]; then
213 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800214 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700215 shift
Alex Light03a112d2014-08-25 13:25:56 -0700216 elif [ "x$1" = "x--no-image" ]; then
217 have_image="no"
218 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700219 elif [ "x$1" = "x--relocate" ]; then
220 relocate="yes"
221 shift
222 elif [ "x$1" = "x--no-relocate" ]; then
223 relocate="no"
224 shift
225 elif [ "x$1" = "x--prebuild" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700226 run_args+=(--prebuild)
Alex Lighta59dd802014-07-02 16:28:08 -0700227 prebuild_mode="yes"
228 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800229 elif [ "x$1" = "x--compact-dex-level" ]; then
230 option="$1"
231 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700232 run_args+=("$option" "$1")
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800233 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700234 elif [ "x$1" = "x--strip-dex" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700235 run_args+=(--strip-dex)
Richard Uhler76f5cb62016-04-04 13:30:16 -0700236 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000237 elif [ "x$1" = "x--debuggable" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700238 run_args+=(-Xcompiler-option --debuggable)
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000239 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000240 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700241 elif [ "x$1" = "x--no-prebuild" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700242 run_args+=(--no-prebuild)
Alex Lighta59dd802014-07-02 16:28:08 -0700243 prebuild_mode="no"
244 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700245 elif [ "x$1" = "x--gcverify" ]; then
246 basic_verify="true"
247 gc_verify="true"
248 shift
249 elif [ "x$1" = "x--gcstress" ]; then
250 basic_verify="true"
251 gc_stress="true"
252 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700253 elif [ "x$1" = "x--jvmti-step-stress" ]; then
254 jvmti_step_stress="true"
255 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700256 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
257 jvmti_redefine_stress="true"
258 shift
Alex Light43e935d2017-06-19 15:40:40 -0700259 elif [ "x$1" = "x--jvmti-field-stress" ]; then
260 jvmti_field_stress="true"
261 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700262 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
263 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700264 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800265 elif [ "x$1" = "x--suspend-timeout" ]; then
266 shift
267 suspend_timeout="$1"
268 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700269 elif [ "x$1" = "x--image" ]; then
270 shift
271 image="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700272 run_args+=(--image "$image")
Elliott Hughes7c046102011-10-19 18:16:03 -0700273 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000274 elif [ "x$1" = "x-Xcompiler-option" ]; then
275 shift
276 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700277 run_args+=(-Xcompiler-option "$option")
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000278 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000279 elif [ "x$1" = "x--build-option" ]; then
280 shift
281 option="$1"
282 build_args="${build_args} $option"
283 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700284 elif [ "x$1" = "x--runtime-option" ]; then
285 shift
286 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700287 run_args+=(--runtime-option "$option")
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700288 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700289 elif [ "x$1" = "x--gdb-arg" ]; then
290 shift
291 gdb_arg="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700292 run_args+=(--gdb-arg "$gdb_arg")
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700293 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700294 elif [ "x$1" = "x--debug" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700295 run_args+=(--debug)
jeffhao5d1ac922011-09-29 17:41:15 -0700296 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700297 elif [ "x$1" = "x--debug-wrap-agent" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700298 run_args+=(--debug-wrap-agent)
Alex Lightc281ba52017-10-11 11:35:55 -0700299 shift
Alex Light0e151e72017-10-25 10:50:35 -0700300 elif [ "x$1" = "x--with-agent" ]; then
301 shift
302 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700303 run_args+=(--with-agent "$1")
Alex Light0e151e72017-10-25 10:50:35 -0700304 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700305 elif [ "x$1" = "x--debug-agent" ]; then
306 shift
307 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700308 run_args+=(--debug-agent "$1")
Alex Lightc281ba52017-10-11 11:35:55 -0700309 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700310 elif [ "x$1" = "x--gdb" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700311 run_args+=(--gdb)
jeffhao5d1ac922011-09-29 17:41:15 -0700312 dev_mode="yes"
313 shift
Alex Lighte4b4a182019-02-12 14:19:49 -0800314 elif [ "x$1" = "x--gdbserver-bin" ]; then
315 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700316 run_args+=(--gdbserver-bin "$1")
Alex Lighte4b4a182019-02-12 14:19:49 -0800317 shift
318 elif [ "x$1" = "x--gdbserver-port" ]; then
319 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700320 run_args+=(--gdbserver-port "$1")
Alex Lighte4b4a182019-02-12 14:19:49 -0800321 shift
322 elif [ "x$1" = "x--gdbserver" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700323 run_args+=(--gdbserver)
Alex Lighte4b4a182019-02-12 14:19:49 -0800324 dev_mode="yes"
325 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700326 elif [ "x$1" = "x--strace" ]; then
327 strace="yes"
Martin Stjernholm4815e722019-09-24 16:20:09 +0100328 run_args+=(--invoke-with strace --invoke-with -o --invoke-with "$tmp_dir/$strace_output")
329 timeout="${timeout:-1800}"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700330 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700331 elif [ "x$1" = "x--zygote" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700332 run_args+=(--zygote)
jeffhao5d1ac922011-09-29 17:41:15 -0700333 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800334 elif [ "x$1" = "x--interpreter" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700335 run_args+=(--interpreter)
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700336 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800337 elif [ "x$1" = "x--jit" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700338 run_args+=(--jit)
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800339 shift
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100340 elif [ "x$1" = "x--baseline" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700341 run_args+=(--baseline)
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100342 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700343 elif [ "x$1" = "x--optimizing" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100344 run_optimizing="true"
jeffhao0dff3f42012-11-20 15:13:43 -0800345 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700346 elif [ "x$1" = "x--no-verify" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700347 run_args+=(--no-verify)
jeffhao5d1ac922011-09-29 17:41:15 -0700348 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700349 elif [ "x$1" = "x--verify-soft-fail" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700350 run_args+=(--verify-soft-fail)
Igor Murashkin7617abd2015-07-10 18:27:47 -0700351 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700352 elif [ "x$1" = "x--no-optimize" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700353 run_args+=(--no-optimize)
jeffhao5d1ac922011-09-29 17:41:15 -0700354 shift
355 elif [ "x$1" = "x--no-precise" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700356 run_args+=(--no-precise)
jeffhao5d1ac922011-09-29 17:41:15 -0700357 shift
Orion Hodson9ca92fb2020-10-28 15:08:11 +0000358 elif [ "x$1" = "x--external-log-tags" ]; then
359 run_args+=(--external-log-tags)
360 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700361 elif [ "x$1" = "x--invoke-with" ]; then
362 shift
363 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700364 if [ "x$what" = "x" ]; then
365 echo "$0 missing argument to --invoke-with" 1>&2
366 usage="yes"
367 break
368 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700369 run_args+=(--invoke-with "${what}")
jeffhao5d1ac922011-09-29 17:41:15 -0700370 shift
Alex Light8d94ddd2019-12-18 11:13:03 -0800371 elif [ "x$1" = "x--create-runner" ]; then
372 run_args+=(--create-runner --dry-run)
373 dev_mode="yes"
374 never_clean="yes"
375 create_runner="yes"
376 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700377 elif [ "x$1" = "x--dev" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700378 run_args+=(--dev)
jeffhao5d1ac922011-09-29 17:41:15 -0700379 dev_mode="yes"
380 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700381 elif [ "x$1" = "x--build-only" ]; then
382 build_only="yes"
383 shift
384 elif [ "x$1" = "x--output-path" ]; then
385 shift
386 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700387 if [ "x$tmp_dir" = "x" ]; then
388 echo "$0 missing argument to --output-path" 1>&2
389 usage="yes"
390 break
391 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700392 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000393 elif [ "x$1" = "x--chroot" ]; then
394 shift
395 if [ "x$1" = "x" ]; then
396 echo "$0 missing argument to --chroot" 1>&2
397 usage="yes"
398 break
399 fi
400 chroot="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700401 run_args+=(--chroot "$1")
Roland Levillain76cfe612017-10-30 13:14:28 +0000402 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000403 elif [ "x$1" = "x--android-root" ]; then
404 shift
405 if [ "x$1" = "x" ]; then
406 echo "$0 missing argument to --android-root" 1>&2
407 usage="yes"
408 break
409 fi
410 android_root="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700411 run_args+=(--android-root "$1")
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000412 shift
Martin Stjernholme58624f2019-09-20 15:53:40 +0100413 elif [ "x$1" = "x--android-art-root" ]; then
Roland Levillain28076142019-01-10 16:39:25 +0000414 shift
415 if [ "x$1" = "x" ]; then
Martin Stjernholme58624f2019-09-20 15:53:40 +0100416 echo "$0 missing argument to --android-art-root" 1>&2
Roland Levillain28076142019-01-10 16:39:25 +0000417 usage="yes"
418 break
419 fi
Martin Stjernholme58624f2019-09-20 15:53:40 +0100420 run_args+=(--android-art-root "$1")
Roland Levillain28076142019-01-10 16:39:25 +0000421 shift
Roland Levillain90b34572019-06-14 15:23:15 +0100422 elif [ "x$1" = "x--android-tzdata-root" ]; then
423 shift
424 if [ "x$1" = "x" ]; then
425 echo "$0 missing argument to --android-tzdata-root" 1>&2
426 usage="yes"
427 break
428 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700429 run_args+=(--android-tzdata-root "$1")
Roland Levillain90b34572019-06-14 15:23:15 +0100430 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700431 elif [ "x$1" = "x--update" ]; then
432 update_mode="yes"
433 shift
434 elif [ "x$1" = "x--help" ]; then
435 usage="yes"
436 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700437 elif [ "x$1" = "x--64" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700438 run_args+=(--64)
Andreas Gampe2fe07922014-04-21 07:50:39 -0700439 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700440 shift
Alex Light680cbf22018-10-31 11:00:19 -0700441 elif [ "x$1" = "x--bionic" ]; then
442 # soong linux_bionic builds are 64bit only.
Andreas Gampe11410de2019-07-02 15:53:53 -0700443 run_args+=(--bionic --host --64)
Alex Light680cbf22018-10-31 11:00:19 -0700444 suffix64="64"
445 target_mode="no"
446 DEX_LOCATION=$tmp_dir
447 host_lib_root=$OUT_DIR/soong/host/linux_bionic-x86
448 shift
Alex Light6f342dd2019-03-27 17:15:42 +0000449 elif [ "x$1" = "x--runtime-extracted-zipapex" ]; then
450 shift
451 # TODO Should we allow the java.library.path to search the zipapex too?
452 # Not needed at the moment and adding it will be complicated so for now
453 # we'll ignore this.
Andreas Gampe11410de2019-07-02 15:53:53 -0700454 run_args+=(--host --runtime-extracted-zipapex "$1")
Alex Light6f342dd2019-03-27 17:15:42 +0000455 target_mode="no"
456 DEX_LOCATION=$tmp_dir
457 shift
Alex Light20802ca2018-12-05 15:36:03 -0800458 elif [ "x$1" = "x--runtime-zipapex" ]; then
459 shift
460 # TODO Should we allow the java.library.path to search the zipapex too?
461 # Not needed at the moment and adding it will be complicated so for now
462 # we'll ignore this.
Andreas Gampe11410de2019-07-02 15:53:53 -0700463 run_args+=(--host --runtime-zipapex "$1")
Alex Light20802ca2018-12-05 15:36:03 -0800464 target_mode="no"
465 DEX_LOCATION=$tmp_dir
466 # apex_payload.zip is quite large we need a high enough ulimit to
467 # extract it. 512mb should be good enough.
468 file_ulimit=512000
469 shift
Martin Stjernholm4815e722019-09-24 16:20:09 +0100470 elif [ "x$1" = "x--timeout" ]; then
471 shift
472 if [ "x$1" = "x" ]; then
473 echo "$0 missing argument to --timeout" 1>&2
474 usage="yes"
475 break
476 fi
477 timeout="$1"
478 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200479 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700480 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200481 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700482 elif [ "x$1" = "x--stream" ]; then
483 trace_stream="true"
484 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700485 elif [ "x$1" = "x--always-clean" ]; then
486 always_clean="yes"
487 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700488 elif [ "x$1" = "x--never-clean" ]; then
489 never_clean="yes"
490 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800491 elif [ "x$1" = "x--dex2oat-swap" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700492 run_args+=(--dex2oat-swap)
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800493 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700494 elif [ "x$1" = "x--instruction-set-features" ]; then
495 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700496 run_args+=(--instruction-set-features "$1")
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700497 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700498 elif [ "x$1" = "x--bisection-search" ]; then
499 bisection_search="yes"
500 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000501 elif [ "x$1" = "x--vdex" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700502 run_args+=(--vdex)
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000503 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000504 elif [ "x$1" = "x--dm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700505 run_args+=(--dm)
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000506 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000507 elif [ "x$1" = "x--vdex-filter" ]; then
508 shift
509 filter=$1
Andreas Gampe11410de2019-07-02 15:53:53 -0700510 run_args+=(--vdex-filter "$filter")
Nicolas Geoffray74981052017-01-16 17:54:09 +0000511 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700512 elif [ "x$1" = "x--random-profile" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700513 run_args+=(--random-profile)
Jeff Hao002b9312017-03-27 16:23:08 -0700514 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700515 elif [ "x$1" = "x--dex2oat-jobs" ]; then
516 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700517 run_args+=(-Xcompiler-option "-j$1")
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700518 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700519 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700520 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700521 usage="yes"
522 break
523 else
524 break
525 fi
526done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700527
Orion Hodson6aa4e0d2018-05-25 09:39:16 +0100528if [ "$usage" = "no" -a "x$1" = "x" ]; then
529 echo "missing test to run" 1>&2
530 usage="yes"
531fi
532
Roland Levillain76cfe612017-10-30 13:14:28 +0000533# The DEX_LOCATION with the chroot prefix, if any.
534chroot_dex_location="$chroot$DEX_LOCATION"
535
Alex Light91de25f2015-10-28 17:00:06 -0700536# Allocate file descriptor real_stderr and redirect it to the shell's error
537# output (fd 2).
538if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
539 exec {real_stderr}>&2
540else
541 # In bash before version 4.1 we need to do a manual search for free file
542 # descriptors.
543 FD=3
544 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
545 real_stderr=$FD
546 eval "exec ${real_stderr}>&2"
547fi
548if [ "$quiet" = "yes" ]; then
549 # Force the default standard output and error to go to /dev/null so we will
550 # not print them.
551 exec 1>/dev/null
552 exec 2>/dev/null
553fi
554
555function err_echo() {
556 echo "$@" 1>&${real_stderr}
557}
558
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700559# tmp_dir may be relative, resolve.
560#
561# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000562# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700563# Cannot use readlink -m, as it does not exist on Mac.
564# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700565noncanonical_tmp_dir=$tmp_dir
Vladimir Markoefbc6592021-04-16 10:29:13 +0000566tmp_dir="`cd $oldwd ; python3 -c "import os; import sys; sys.stdout.write(os.path.realpath('$tmp_dir'))"`"
Andreas Gampe86459c02019-08-29 14:01:18 -0700567if [ -z $tmp_dir ] ; then
568 err_echo "Failed to resolve $tmp_dir"
569 exit 1
570fi
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700571mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700572
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800573# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000574if [ ! "$runtime" = "jvm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700575 run_args+=(--runtime-option "-XX:ThreadSuspendTimeout=$suspend_timeout")
Narayan Kamathf86c3932017-01-24 17:40:47 +0000576fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800577
Alex Lighte7873ec2014-08-12 09:53:50 -0700578if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800579 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
Andreas Gampe11410de2019-07-02 15:53:53 -0700580 run_args+=(--runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0)
Alex Lighte7873ec2014-08-12 09:53:50 -0700581fi
582if [ "$gc_verify" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700583 run_args+=(--runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc)
Alex Lighte7873ec2014-08-12 09:53:50 -0700584fi
585if [ "$gc_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700586 run_args+=(--gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m)
Alex Lighte7873ec2014-08-12 09:53:50 -0700587fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700588if [ "$jvmti_redefine_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700589 run_args+=(--no-app-image --jvmti-redefine-stress)
Alex Lightb7edcda2017-04-27 13:20:31 -0700590fi
Alex Lightc38c3692017-06-27 15:45:14 -0700591if [ "$jvmti_step_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700592 run_args+=(--no-app-image --jvmti-step-stress)
Alex Lightc38c3692017-06-27 15:45:14 -0700593fi
Alex Light43e935d2017-06-19 15:40:40 -0700594if [ "$jvmti_field_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700595 run_args+=(--no-app-image --jvmti-field-stress)
Alex Light43e935d2017-06-19 15:40:40 -0700596fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700597if [ "$jvmti_trace_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700598 run_args+=(--no-app-image --jvmti-trace-stress)
Alex Light8f2c6d42017-04-10 16:27:35 -0700599fi
Jeff Hao85139a32014-07-23 11:52:52 -0700600if [ "$trace" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700601 run_args+=(--runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000)
Andreas Gampe7526d782015-06-22 22:53:45 -0700602 if [ "$trace_stream" = "true" ]; then
603 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
604 # the ability to analyze the file and just write to /dev/null.
Andreas Gampe11410de2019-07-02 15:53:53 -0700605 run_args+=(--runtime-option -Xmethod-trace-file:/dev/null)
Andreas Gampe7526d782015-06-22 22:53:45 -0700606 # Enable streaming mode.
Andreas Gampe11410de2019-07-02 15:53:53 -0700607 run_args+=(--runtime-option -Xmethod-trace-stream)
Andreas Gampe7526d782015-06-22 22:53:45 -0700608 else
Andreas Gampe11410de2019-07-02 15:53:53 -0700609 run_args+=(--runtime-option "-Xmethod-trace-file:${DEX_LOCATION}/trace.bin")
Andreas Gampe7526d782015-06-22 22:53:45 -0700610 fi
611elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700612 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700613 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700614fi
Martin Stjernholm4815e722019-09-24 16:20:09 +0100615if [ -n "$timeout" ]; then
616 run_args+=(--timeout "$timeout")
617fi
Jeff Hao85139a32014-07-23 11:52:52 -0700618
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700619# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000620# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100621function guess_target_arch_name() {
Andreas Gamped0566d42018-06-06 09:54:34 -0700622 # Check whether this is a device with native bridge. Currently this is hardcoded
623 # to x86 + arm.
David Srbecky928d28e2020-04-01 17:50:51 +0100624 local guess_path=${ANDROID_PRODUCT_OUT}/system/apex/com.android.art.testing/javalib
625 local x86_arm=`ls ${guess_path} | sort | grep -E '^(arm|x86)$'`
Andreas Gamped0566d42018-06-06 09:54:34 -0700626 # Collapse line-breaks into spaces
627 x86_arm=$(echo $x86_arm)
628 if [ "x$x86_arm" = "xarm x86" ] ; then
629 err_echo "Native-bridge configuration detected."
630 # We only support the main arch for tests.
631 if [ "x${suffix64}" = "x64" ]; then
632 target_arch_name=""
633 else
634 target_arch_name=x86
635 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700636 else
David Srbecky928d28e2020-04-01 17:50:51 +0100637 local grep32bit=`ls ${guess_path} | grep -E '^(arm|x86)$'`
638 local grep64bit=`ls ${guess_path} | grep -E '^(arm64|x86_64)$'`
Andreas Gamped0566d42018-06-06 09:54:34 -0700639 if [ "x${suffix64}" = "x64" ]; then
640 target_arch_name=${grep64bit}
641 else
642 target_arch_name=${grep32bit}
643 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700644 fi
645}
646
David Brazdil853a4c32015-09-28 16:15:50 +0100647function guess_host_arch_name() {
648 if [ "x${suffix64}" = "x64" ]; then
649 host_arch_name="x86_64"
650 else
651 host_arch_name="x86"
652 fi
653}
654
Alex Lighta59dd802014-07-02 16:28:08 -0700655if [ "$target_mode" = "no" ]; then
656 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700657 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700658 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000659 exit 1
660 fi
661 else
662 # ART/Dalvik host mode.
663 if [ -n "$chroot" ]; then
664 err_echo "--chroot with --host is unsupported"
665 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700666 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700667 fi
668fi
669
Jeff Hao201803f2013-11-20 18:11:39 -0800670if [ ! "$runtime" = "jvm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700671 run_args+=(--lib "$lib")
Jeff Hao201803f2013-11-20 18:11:39 -0800672fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700673
Jeff Hao201803f2013-11-20 18:11:39 -0800674if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700675 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000676 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Victor Chang759845f2019-08-06 16:04:36 +0100677 bpath="${framework}/core-icu4j.jar:${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Andreas Gampe11410de2019-07-02 15:53:53 -0700678 run_args+=(--boot --runtime-option "-Xbootclasspath:${bpath}")
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700679 else
680 true # defaults to using target BOOTCLASSPATH
681 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800682elif [ "$runtime" = "art" ]; then
Ulya Trafimovich5439f052020-07-29 10:03:46 +0100683 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100684 guess_host_arch_name
Martin Stjernholm9fde2db2020-10-15 16:03:29 +0100685 run_args+=(--boot "${ANDROID_HOST_OUT}/apex/art_boot_images/javalib/boot.art")
Andreas Gampe11410de2019-07-02 15:53:53 -0700686 run_args+=(--runtime-option "-Djava.library.path=${host_lib_root}/lib${suffix64}:${host_lib_root}/nativetest${suffix64}")
Jeff Hao201803f2013-11-20 18:11:39 -0800687 else
David Brazdil853a4c32015-09-28 16:15:50 +0100688 guess_target_arch_name
Martin Stjernholm0d0f8df2021-04-28 16:47:01 +0100689 # Note that libarttest(d).so and other test libraries that depend on ART
690 # internal libraries must not be in this path for JNI libraries - they
691 # need to be loaded through LD_LIBRARY_PATH and
692 # NATIVELOADER_DEFAULT_NAMESPACE_LIBS instead.
Andreas Gampe11410de2019-07-02 15:53:53 -0700693 run_args+=(--runtime-option "-Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}")
David Srbecky928d28e2020-04-01 17:50:51 +0100694 run_args+=(--boot "/apex/com.android.art/javalib/boot.art")
Jeff Hao201803f2013-11-20 18:11:39 -0800695 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700696 if [ "$relocate" = "yes" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700697 run_args+=(--relocate)
Alex Lighta59dd802014-07-02 16:28:08 -0700698 else
Andreas Gampe11410de2019-07-02 15:53:53 -0700699 run_args+=(--no-relocate)
Alex Lighta59dd802014-07-02 16:28:08 -0700700 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700701elif [ "$runtime" = "jvm" ]; then
702 # TODO: Detect whether the host is 32-bit or 64-bit.
Andreas Gampe11410de2019-07-02 15:53:53 -0700703 run_args+=(--runtime-option "-Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64")
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700704fi
705
Alex Light03a112d2014-08-25 13:25:56 -0700706if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700707 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700708 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700709 exit 1
710 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700711 run_args+=(--no-image)
Alex Light03a112d2014-08-25 13:25:56 -0700712fi
713
Alex Light8d94ddd2019-12-18 11:13:03 -0800714if [ "$create_runner" = "yes" -a "$target_mode" = "yes" ]; then
715 err_echo "--create-runner does not function for non --host tests"
716 usage="yes"
717fi
718
jeffhao5d1ac922011-09-29 17:41:15 -0700719if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700720 err_echo "--dev and --update are mutually exclusive"
721 usage="yes"
722fi
723
724if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
725 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700726 usage="yes"
727fi
728
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700729if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
730 err_echo "--bisection-search and --prebuild are mutually exclusive"
731 usage="yes"
732fi
733
Roland Levillain76cfe612017-10-30 13:14:28 +0000734# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
735if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
736 err_echo "--chroot with --bisection-search is unsupported"
737 exit 1
738fi
739
jeffhao5d1ac922011-09-29 17:41:15 -0700740if [ "$usage" = "no" ]; then
741 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
742 test_dir=`basename "$oldwd"`
743 else
744 test_dir="$1"
745 fi
746
747 if [ '!' -d "$test_dir" ]; then
748 td2=`echo ${test_dir}-*`
749 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700750 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700751 usage="yes"
752 fi
753 test_dir="$td2"
754 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700755 # Shift to get rid of the test name argument. The rest of the arguments
756 # will get passed to the test run.
757 shift
758fi
759
760if [ "$usage" = "yes" ]; then
761 prog=`basename $prog`
762 (
763 echo "usage:"
764 echo " $prog --help Print this message."
765 echo " $prog [options] [test-name] Run test normally."
766 echo " $prog --dev [options] [test-name] Development mode" \
767 "(dumps to stdout)."
Alex Light8d94ddd2019-12-18 11:13:03 -0800768 echo " $prog --create-runner [options] [test-name]"
769 echo " Creates a runner script for use with other " \
770 "tools (e.g. parallel_run.py)."
771 echo " The script will only run the test portion, and " \
772 "share oat and dex files."
jeffhao5d1ac922011-09-29 17:41:15 -0700773 echo " $prog --update [options] [test-name] Update mode" \
Roland Levillainb15e8792020-10-28 12:20:59 +0000774 "(replaces expected-stdout.txt and expected-stderr.txt)."
jeffhao5d1ac922011-09-29 17:41:15 -0700775 echo ' Omitting the test name or specifying "-" will use the' \
776 "current directory."
777 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000778 echo " -O Run non-debug rather than debug build (off by default)."
779 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000780 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000781 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800782 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700783 echo " --debug Wait for the default debugger to attach."
784 echo " --debug-agent <agent-path>"
785 echo " Wait for the given debugger agent to attach. Currently"
786 echo " only supported on host."
787 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
788 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700789 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000790 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000791 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lighte4b4a182019-02-12 14:19:49 -0800792 echo " --gdbserver Start gdbserver (defaults to port :5039)."
793 echo " --gdbserver-port <port>"
794 echo " Start gdbserver with the given COMM (see man gdbserver)."
795 echo " --gdbserver-bin <binary>"
796 echo " Use the given binary as gdbserver."
797 echo " --gdb-arg Pass an option to gdb or gdbserver."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000798 echo " --build-only Build test files only (off by default)."
799 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800800 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000801 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000802 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700803 echo " --verify-soft-fail Force soft fail verification (off by default)."
804 echo " Verification is enabled if neither --no-verify"
805 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000806 echo " --no-optimize Turn off optimization (on by default)."
807 echo " --no-precise Turn off precise GC (on by default)."
808 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700809 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000810 echo " other runtime options are ignored."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000811 echo " --prebuild Run dex2oat on the files before starting test. (default)"
812 echo " --no-prebuild Do not run dex2oat on the files before starting"
813 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700814 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000815 echo " --relocate Force the use of relocating in the test, making"
816 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000817 echo " address before running."
818 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700819 echo " --image Run the test using a precompiled boot image. (default)"
820 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000821 echo " --host Use the host-mode virtual machine."
822 echo " --invoke-with Pass --invoke-with option to runtime."
823 echo " --dalvik Use Dalvik (off by default)."
824 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700825 echo " --use-java-home Use the JAVA_HOME environment variable"
826 echo " to find the java compiler and runtime"
827 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000828 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700829 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000830 echo " --64 Run the test in 64-bit mode"
Alex Light680cbf22018-10-31 11:00:19 -0700831 echo " --bionic Use the (host, 64-bit only) linux_bionic libc runtime"
Alex Light20802ca2018-12-05 15:36:03 -0800832 echo " --runtime-zipapex [file]"
833 echo " Use the given zipapex file to provide runtime binaries"
Alex Light6f342dd2019-03-27 17:15:42 +0000834 echo " --runtime-extracted-zipapex [dir]"
835 echo " Use the given extracted zipapex directory to provide"
836 echo " runtime binaries"
Martin Stjernholm4815e722019-09-24 16:20:09 +0100837 echo " --timeout n Test timeout in seconds"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000838 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700839 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700840 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000841 echo " --gcstress Run with gc stress testing"
842 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700843 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700844 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700845 echo " --jvmti-redefine-stress"
846 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000847 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700848 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000849 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000850 echo " --android-root [path] The path on target for the android root. (/system by default)."
Victor Chang64611242019-07-05 16:32:41 +0100851 echo " --android-i18n-root [path]"
852 echo " The path on target for the i18n module root."
853 echo " (/apex/com.android.i18n by default)."
Martin Stjernholme58624f2019-09-20 15:53:40 +0100854 echo " --android-art-root [path]"
855 echo " The path on target for the ART module root."
Martin Stjernholmd6be5da2019-07-16 17:14:46 +0100856 echo " (/apex/com.android.art by default)."
Roland Levillain90b34572019-06-14 15:23:15 +0100857 echo " --android-tzdata-root [path]"
858 echo " The path on target for the Android Time Zone Data root."
859 echo " (/apex/com.android.tzdata by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000860 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700861 echo " --instruction-set-features [string]"
862 echo " Set instruction-set-features for compilation."
Alex Light91de25f2015-10-28 17:00:06 -0700863 echo " --quiet Don't print anything except failure messages"
Orion Hodson9ca92fb2020-10-28 15:08:11 +0000864 echo " --external-log-tags Use ANDROID_LOG_TAGS to set a custom logging level for"
865 echo " a test run."
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700866 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000867 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800868 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700869 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700870 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700871 exit 1
872fi
873
874cd "$test_dir"
875test_dir=`pwd`
876
877td_info="${test_dir}/${info}"
Roland Levillainb15e8792020-10-28 12:20:59 +0000878td_expected_stdout="${test_dir}/${expected_stdout}"
879td_expected_stderr="${test_dir}/${expected_stderr}"
jeffhao5d1ac922011-09-29 17:41:15 -0700880
Roland Levillainb15e8792020-10-28 12:20:59 +0000881for td_file in "$td_info" "$td_expected_stdout" "$td_expected_stderr"; do
882 if [ ! -r "$td_file" ]; then
883 err_echo "${test_dir}: missing file $td_file"
884 exit 1
885 fi
886done
jeffhao5d1ac922011-09-29 17:41:15 -0700887
888# copy the test to a temp dir and run it
889
Elliott Hughes510c8782011-10-06 10:57:34 -0700890echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700891
892rm -rf "$tmp_dir"
Alex Light0aa7a5a2018-10-10 15:58:14 +0000893cp -LRp "$test_dir" "$tmp_dir"
jeffhao5d1ac922011-09-29 17:41:15 -0700894cd "$tmp_dir"
895
896if [ '!' -r "$build" ]; then
897 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800898else
899 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700900fi
901
902if [ '!' -r "$run" ]; then
903 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800904else
905 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700906fi
907
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700908if [ '!' -r "$check_cmd" ]; then
909 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800910else
911 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700912fi
913
jeffhao5d1ac922011-09-29 17:41:15 -0700914chmod 755 "$build"
915chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700916chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700917
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700918export TEST_NAME=`basename ${test_dir}`
919
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000920# Tests named '<number>-checker-*' will also have their CFGs verified with
921# Checker when compiled with Optimizing on host.
922if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffray8c41a0b2020-02-06 16:52:11 +0000923 if [ "$runtime" = "art" -a "$run_optimizing" = "true" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000924 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
925 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
926 run_checker="yes"
927
Ulya Trafimovich5439f052020-07-29 10:03:46 +0100928 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000929 cfg_output_dir="$tmp_dir"
930 checker_args="--arch=${host_arch_name^^}"
931 else
932 cfg_output_dir="$DEX_LOCATION"
933 checker_args="--arch=${target_arch_name^^}"
934 fi
935
936 if [ "$debuggable" = "yes" ]; then
937 checker_args="$checker_args --debuggable"
938 fi
939
Andreas Gampe11410de2019-07-02 15:53:53 -0700940 run_args+=(-Xcompiler-option "--dump-cfg=$cfg_output_dir/$cfg_output" -Xcompiler-option -j1)
Daniil Riazanovskiybfe8fc82020-10-05 15:07:15 +0000941 checker_args="$checker_args --print-cfg"
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000942 fi
943 fi
944fi
945
Andreas Gampe11410de2019-07-02 15:53:53 -0700946run_args+=(--testlib "${testlib}")
Mathieu Chartier031768a2015-08-27 10:25:02 -0700947
Alex Light20802ca2018-12-05 15:36:03 -0800948if ! ulimit -f ${file_ulimit}; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000949 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700950fi
951
Igor Murashkin2de6e082018-02-28 15:25:23 -0800952# Tell the build script which mode (target, host, jvm) we are building for
953# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000954if [[ "$target_mode" == "yes" ]]; then
955 build_args="$build_args --target"
956else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800957 if [[ $runtime == "jvm" ]]; then
958 build_args="$build_args --jvm"
959 else
960 build_args="$build_args --host"
961 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000962fi
963
964if [[ "$dev_mode" == "yes" ]]; then
965 build_args="$build_args --dev"
966fi
967
jeffhao5d1ac922011-09-29 17:41:15 -0700968good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000969good_build="yes"
970good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700971export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700972if [ "$dev_mode" = "yes" ]; then
Roland Levillainb15e8792020-10-28 12:20:59 +0000973 "./${build}" $build_args
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700974 build_exit="$?"
975 echo "build exit status: $build_exit" 1>&2
976 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800977 echo "${test_dir}: running..." 1>&2
Roland Levillainb15e8792020-10-28 12:20:59 +0000978 "./${run}" "${run_args[@]}" "$@"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700979 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000980
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800981 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000982 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100983 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000984 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100985 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100986 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000987 checker_exit="$?"
988 if [ "$checker_exit" = "0" ]; then
989 good="yes"
990 fi
Alex Light91de25f2015-10-28 17:00:06 -0700991 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000992 else
993 good="yes"
994 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800995 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000996 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700997 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700998elif [ "$update_mode" = "yes" ]; then
Roland Levillainb15e8792020-10-28 12:20:59 +0000999 "./${build}" $build_args >"$build_stdout" 2>"$build_stderr"
jeffhao5d1ac922011-09-29 17:41:15 -07001000 build_exit="$?"
1001 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -08001002 echo "${test_dir}: running..." 1>&2
Roland Levillainb15e8792020-10-28 12:20:59 +00001003 "./${run}" "${run_args[@]}" "$@" >"$test_stdout" 2>"$test_stderr"
David Brazdil4846d132015-01-15 19:07:08 +00001004 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001005 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001006 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001007 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001008 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >>"$test_stdout" 2>>"$test_stderr"
David Brazdil4846d132015-01-15 19:07:08 +00001009 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001010 sed -e 's/[[:cntrl:]]$//g' <"$test_stdout" >"${td_expected_stdout}"
1011 sed -e 's/[[:cntrl:]]$//g' <"$test_stderr" >"${td_expected_stderr}"
jeffhao5d1ac922011-09-29 17:41:15 -07001012 good="yes"
1013 else
Roland Levillainb15e8792020-10-28 12:20:59 +00001014 err_echo "#################### build standard output"
1015 cat "$build_stdout" 1>&${real_stderr}
1016 err_echo "####################"
1017 err_echo "#################### build standard error"
1018 cat "$build_stderr" 1>&${real_stderr}
1019 err_echo "####################"
Alex Light91de25f2015-10-28 17:00:06 -07001020 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -07001021 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001022elif [ "$build_only" = "yes" ]; then
1023 good="yes"
Roland Levillainb15e8792020-10-28 12:20:59 +00001024 "./${build}" $build_args >"$build_stdout" 2>"$build_stderr"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001025 build_exit="$?"
1026 if [ "$build_exit" '!=' '0' ]; then
Roland Levillainb15e8792020-10-28 12:20:59 +00001027 cp "$build_stdout" "$test_stdout"
1028 diff --strip-trailing-cr -q "$expected_stdout" "$test_stdout" >/dev/null
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001029 if [ "$?" '!=' "0" ]; then
1030 good="no"
Roland Levillainb15e8792020-10-28 12:20:59 +00001031 err_echo "BUILD FAILED For ${TEST_NAME}" \
1032 "(the build's standard output does not match the expected standard output)"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001033 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001034 cp "$build_stderr" "$test_stderr"
1035 diff --strip-trailing-cr -q "$expected_stderr" "$test_stderr" >/dev/null
1036 if [ "$?" '!=' "0" ]; then
1037 good="no"
1038 err_echo "BUILD FAILED For ${TEST_NAME}" \
1039 "(the build's standard error does not match the expected standard error)"
1040 fi
1041 echo "build exit status: $build_exit" >>"$test_stderr"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001042 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -07001043 # Clean up extraneous files that are not used by tests.
Roland Levillainb15e8792020-10-28 12:20:59 +00001044 find $tmp_dir -mindepth 1 \
1045 ! -regex ".*/\(.*jar\|$test_stdout\|$expected_stdout|$test_stderr\|$expected_stderr\)" \
1046 | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001047 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -07001048else
Roland Levillainb15e8792020-10-28 12:20:59 +00001049 "./${build}" $build_args >"$build_stdout" 2>"$build_stderr"
jeffhao5d1ac922011-09-29 17:41:15 -07001050 build_exit="$?"
1051 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -08001052 echo "${test_dir}: running..." 1>&2
Roland Levillainb15e8792020-10-28 12:20:59 +00001053 "./${run}" "${run_args[@]}" "$@" >"$test_stdout" 2>"$test_stderr"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001054 run_exit="$?"
1055 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -07001056 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001057 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +00001058 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001059 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001060 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001061 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001062 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >>"$test_stdout" 2>>"$test_stderr"
David Brazdil4846d132015-01-15 19:07:08 +00001063 checker_exit="$?"
1064 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -07001065 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +00001066 good_run="no"
1067 else
1068 good_run="yes"
1069 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001070 else
1071 good_run="yes"
1072 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001073 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001074 good_build="no"
Roland Levillainb15e8792020-10-28 12:20:59 +00001075 cp "$build_stdout" "$test_stdout"
1076 cp "$build_stderr" "$test_stderr"
1077 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" \
1078 >> "$test_stderr"
1079 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$test_stderr"
1080 echo "Args: ${args}" >> "$test_stderr"
1081 echo "build exit status: $build_exit" >> "$test_stderr"
Andreas Gampe5c114902014-10-27 17:03:58 -07001082 max_name_length=$(getconf NAME_MAX ${tmp_dir})
Roland Levillainb15e8792020-10-28 12:20:59 +00001083 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$test_stderr"
Andreas Gampe5c114902014-10-27 17:03:58 -07001084 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Roland Levillainb15e8792020-10-28 12:20:59 +00001085 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$test_stderr"
jeffhao5d1ac922011-09-29 17:41:15 -07001086 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001087 ./$check_cmd "$expected_stdout" "$test_stdout" "$expected_stderr" "$test_stderr"
jeffhao5d1ac922011-09-29 17:41:15 -07001088 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001089 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
Roland Levillainb15e8792020-10-28 12:20:59 +00001090 # test_stdout == expected_stdout && test_stderr == expected_stderr
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001091 good="yes"
1092 echo "${test_dir}: succeeded!" 1>&2
1093 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001094 fi
1095fi
1096
jeffhao5d1ac922011-09-29 17:41:15 -07001097(
Alex Lightbfac14a2014-07-30 09:41:21 -07001098 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -07001099 echo "${test_dir}: FAILED!"
1100 echo ' '
1101 echo '#################### info'
1102 cat "${td_info}" | sed 's/^/# /g'
Roland Levillainb15e8792020-10-28 12:20:59 +00001103 echo '#################### stdout diffs'
Nicolas Geoffray30a11eb2020-01-28 16:04:01 +00001104 if [ "$run_checker" == "yes" ]; then
1105 # Checker failures dump the whole CFG, so we output the whole diff.
Roland Levillainb15e8792020-10-28 12:20:59 +00001106 diff --strip-trailing-cr -u "$expected_stdout" "$test_stdout"
Nicolas Geoffray30a11eb2020-01-28 16:04:01 +00001107 else
Roland Levillainb15e8792020-10-28 12:20:59 +00001108 diff --strip-trailing-cr -u "$expected_stdout" "$test_stdout" | tail -n 10000
Nicolas Geoffray30a11eb2020-01-28 16:04:01 +00001109 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001110 echo '####################'
Roland Levillainb15e8792020-10-28 12:20:59 +00001111 echo '#################### stderr diffs'
1112 diff --strip-trailing-cr -u "$expected_stderr" "$test_stderr" | tail -n 10000
1113 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001114 if [ "$strace" = "yes" ]; then
1115 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -07001116 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001117 echo '####################'
1118 fi
Andreas Gampee79ca192017-07-31 10:30:16 -07001119 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
1120 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
1121 # tools used by the given ABI work for both x86 and x86-64.
Roland Levillainb15e8792020-10-28 12:20:59 +00001122 echo "ABI: 'x86_64'" | cat - "$test_stdout" "$test_stderr" \
1123 | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
Andreas Gampee79ca192017-07-31 10:30:16 -07001124 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001125 echo ' '
1126 fi
Alex Lightbfac14a2014-07-30 09:41:21 -07001127
Alex Light91de25f2015-10-28 17:00:06 -07001128) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -07001129
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001130# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +00001131# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001132if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
1133 # Bisecting works by skipping different optimization passes which breaks checker assertions.
1134 if [ "$run_checker" == "yes" ]; then
1135 echo "${test_dir}: not bisecting, checker test." 1>&2
1136 else
1137 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001138 echo "${test_dir}: bisecting..." 1>&2
1139 cwd=`pwd`
1140 maybe_device_mode=""
1141 raw_cmd=""
1142 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001143 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001144 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1145 # to exec in order to preserve pid when calling dalvikvm. This is required
1146 # for bisection search to correctly retrieve logs from device.
Andreas Gampe11410de2019-07-02 15:53:53 -07001147 "./${run}" "${run_args[@]}" --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +00001148 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001149 maybe_device_mode="--device"
1150 raw_cmd="$DEX_LOCATION/cmdline.sh"
1151 else
Andreas Gampe11410de2019-07-02 15:53:53 -07001152 raw_cmd="$cwd/${run} --external-log-tags "${run_args[@]}" $@"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001153 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001154 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001155 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1156 $maybe_device_mode \
1157 --raw-cmd="$raw_cmd" \
1158 --check-script="$cwd/check" \
Roland Levillaina073f462020-10-28 12:48:24 +00001159 --expected-output="$cwd/expected-stdout.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001160 --logfile="$cwd/bisection_log.txt" \
Martin Stjernholm4815e722019-09-24 16:20:09 +01001161 --timeout=${timeout:-300}
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001162 fi
1163fi
1164
Alex Lightbfac14a2014-07-30 09:41:21 -07001165# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001166if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001167 cd "$oldwd"
1168 rm -rf "$tmp_dir"
1169 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001170 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001171 fi
1172 if [ "$good" = "yes" ]; then
1173 exit 0
1174 fi
1175fi
1176
1177
1178(
1179 if [ "$always_clean" = "yes" ]; then
1180 echo "${TEST_NAME} files deleted from host "
1181 if [ "$target_mode" == "yes" ]; then
1182 echo "and from target"
1183 fi
1184 else
1185 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1186 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001187 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001188 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001189 fi
1190
Alex Light91de25f2015-10-28 17:00:06 -07001191) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001192
Alex Light6a870fa2016-05-31 16:36:19 -07001193if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1194 exit 0
1195else
1196 exit 1
1197fi